/*
 * Copyright (c) 2018-2999 广州亚米信息科技有限公司 All rights reserved.
 *
 * https://www.gz-yami.com/
 *
 * 未经允许，不可做商业用途！
 *
 * 版权所有，侵权必究！
 */

package com.yami.shop.dao;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yami.shop.bean.app.dto.ShopHeadInfoDto;
import com.yami.shop.bean.model.ShopDetail;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.yami.shop.common.util.PageParam;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author LGH
 */
public interface ShopDetailMapper extends BaseMapper<ShopDetail> {

    /**
     * 根据店铺的手机号（登陆账号），获取店铺信息
     *
     * @param mobile 手机号
     * @return
     */
    ShopDetail getShopByMobile(@Param("mobile") String mobile);

    void updatePasswordByUserName(@Param("username") String username, @Param("newPassword") String newPassword);

    ShopDetail getShopDetailByUserId(@Param("userId") String userId);

    /**
     * 根据
     */
    ShopDetail selectByOutStationNo(@Param("outStationNo") String outStationNo);

    /**
     * 根据海博编码查询门店信息
     *
     * @param hbStationId 海博门店编码
     * @return
     */
    ShopDetail selectByHbStationId(@Param("hbStationId") String hbStationId);

    /**
     * 修改店铺状态
     */
    void updateStatus(@Param("shopId") Long shopId, @Param("status") Integer status);


    /**
     * 修改营业状态和经营状态
     * @return
     */
    void hbUpdateStatus(@Param("shopId") Long shopId, @Param("shopStatus") Integer shopStatus, @Param("runStatus") Integer runStatus);


    List<ShopHeadInfoDto> listHotShopsHead();

    Page<ShopHeadInfoDto> searchShops(@Param("page") PageParam<ShopHeadInfoDto> page, @Param("shopHeadInfoDto") ShopHeadInfoDto shopHeadInfoDto);

    ShopDetail selectShopDetailById(@Param("shopId") Long shopId);

    List<ShopDetail> neighborShop(@Param("lat") String lat,
                                  @Param("lon") String lon, @Param("channelId") Long channelId);


}
